#include <iostream>
#include <algorithm>

using namespace std;

long long a[80000],b[80000];
int result[10];

int main()
{
    int t,n,m,res=1;
    long long x;
    cin>>t;
    for(int k=0;k<t;k++)
    {
        res=1;
        cin>>n>>m;
        for(int i=0;i<n;i++)
        {
            cin>>a[i];
        }
        for(int j=0;j<m;j++)
        {
            cin>>b[j];
        }
        sort(a,a+n);
        sort(b,b+m);
        x=a[1]-a[0];
        long long prev=x;
        for(int i=1;i<n-1;i++)
        {
            x=a[i+1]-a[i];
            if(x<prev)
            {
                if(prev%x==0)
                {
                    prev=x;
                }
                else
                {
                    res=0;
                    break;
                }
            }
            else if(x%prev!=0)
            {
                res=0;
                break;
            }
        }
        for(int i=0;i<m;i++)
        {
            b[i]-=a[0];
            if(b[i]%prev==0)
            {
                res=0;
                break;
            }
        }
        result[k]=res;
    }
    for(int i=0;i<t;i++)
    {
        cout<<result[i]<<endl;
    }
}